# Time-stamp: <modified the 14/04/2020 (at 16:50) by Erwan Jahier>

DIR=../../_build/install/default

sasa=$(DIR)/bin/sasa  -l 100
sasa=sasa

LIB=-package algo
ifndef DAEMON
	DAEMON=-dd
endif

.PRECIOUS: %.ml
%.ml: %.dot 
	sasa -reg $<

%.cmxs: %.ml
	ocamlfind ocamlopt $(LIB) -shared state.ml $(shell sasa -algo $*.dot) $< -o $@

%.cma: %.ml
	ocamlfind ocamlc -a $(LIB)  state.ml $(shell sasa -algo $*.dot) $< -o $@

%.lut: %.dot %.cmxs
	sasa -gld $< || echo "==> ok, I'll use the existing $@ file"

%_oracle.lus: %.dot %.cmxs
	sasa -glos $< || echo "==> ok, I'll use the existing $@ file"

%.rif: %.cmxs %.dot
	$(sasa) $(sasaopt) $*.dot -rif > $*.rif

%.pdf:
	osage -Tpdf $*.dot -o $*.pdf
	xpdf $*.pdf

%.ocd: %.ml
	rdbg -camldebug -sut "sasa $.dot" -l 1000

%.test: %.dot %.cmxs
	sasa  $< 

%.rdbg: %.dot %.ml
	ledit -h rdbg-history -x rdbg -sut "sasa $< $(DAEMON)" 

%.rdbgui: %.dot %.ml
	ledit -h rdbg-history -x rdbgui4sasa -sut "sasa $< $(DAEMON)" 



g:gnuplot
s:sim2chrogtk

genclean:
	rm -f *.cmxs sasa *.cm* *.o *.pdf *.rif *.gp *.log *.dro *.seed *.c *.h sasa-*.dot
	rm -f rdbg-session*.ml luretteSession* *.lut a.out *.cov read_dot.ml
	rm -f *.exec *.sh  grid*.ml read_dot.ml rdbg-history

##################################################################################
-include Makefile.untracked
