#use "genExpeMakefiles.ml";;
precision := 0.01;;
    (* 0.01 means that we simulate until the Confidence Interval
       size of  the 3 complexity  numbers under estimation  is smaller
       than 1% of their current estimation.
    *)
let algos = ["../../test/alea-coloring-alt";
             "../../test/alea-coloring-unif";
             "../../test/alea-coloring"]
let daemons = ["-sd";"-lcd";"-dd"]  
(* let cliques = List.init 25 (fun n -> Clique (20*(n+1))) (* [20; 40; ...; 500] *) *)
(* let rings = List.init 25 (fun n -> Ring (400*(n+1)))  (* [400; 800; ...; 10000] *) *)
(* let er = List.init 25 (fun n -> ER (10*(n+1), 0.4)) (* [10; 20; ...; 250] *) *)
let rings = List.init 10 (fun n -> Ring (500*(n+1)))    (* [500; 1000; ...; 5000] *)
let cliques = List.init 10 (fun n -> Clique (30*(n+1))) (* [30; 60; ...; 300] *)
let er = List.init 10 (fun n -> ER (30*(n+1), 0.4))     (* [30; 60; ...; 300] *)
    
let gen_make_rules () = 
  let fn = "Makefile.expe-rules" in
  let oc = open_out fn in
  Printf.fprintf oc "# Generated by coloring_campaign.ml";
  let compare_neg x y = compare y x in
  let l = List.sort_uniq compare_neg (cliques @ rings @ er) in 
  let targets,targets_cmxs = gen_makefile oc daemons algos l [] [] in
  Printf.fprintf oc "\nCMXS=%s\n"  (String.concat " " targets_cmxs);
  Printf.fprintf oc "\nLOG=%s\n%!" (String.concat " " targets);
  Printf.printf "%s has been generated\n%!" fn;
  close_out oc
;;



#use "parseLog.ml";;
let gen_pdf () =
  let gl = ["clique"; "ring"; "er"] in 
  List.iter (fun n -> sh ("rm -f "^n^".data")) gl; 
  parse_log ["Uniform When Activated","alea-coloring-unif"] gl daemons;
  parse_log ["Smallest When Activated","alea-coloring"] gl daemons;
  parse_log ["Always the Biggest","alea-coloring-alt"] gl daemons;    
  List.iter (fun n -> sh ("./gen_pdf_paper.r "^n^".data coloring")) gl;
  ()
;;

