#use "genExpeMakefiles.ml";;
precision := 0.1;;
(* 0.1  means that we simulate until the  onfidence Interval  size of
   the 3  complexity numbers under  estimation is smaller than  10% of
   their current estimation.

   Starting with  10% to  get a  rough idea of  the complexity  in the
   first place is probably a wise idea.  *)
max_simu_nb := 1000;; (* by default, it's more *)
timeout_in_sec := 60;; (* ditto *)
let algos = ["../../test/alea-coloring-alt";
             "../../test/alea-coloring-unif";
             "../../test/alea-coloring"]
let daemons = ["-sd";"-lcd";"-dd"]  
let cliques = List.init 5 (fun n -> Clique (10*(n+1))) (* [10; 20; ...; 50] *)
let rings = List.init 5 (fun n -> Ring (100*(n+1))) (* [100; 200; ...; 500] *)
let er = List.init 5 (fun n -> ER (20*(n+1), 0.4)) (* [20; 40; ...; 100] *)
    
let gen_make_rules () = 
  let fn = "Makefile.expe-rules" in
  let oc = open_out fn in
  Printf.fprintf oc "# Generated by nonreg_test_campaign.ml";
  (* 5 Cliques and 5 rings (not too big for the CI scripts) *)
  let compare_neg x y = compare y x in
  let l = List.sort_uniq compare_neg (cliques @ rings @ er) in
  let targets,targets_cmxs = gen_makefile oc daemons algos l [] [] in
  Printf.fprintf oc "\nCMXS=%s\n" (String.concat " " targets_cmxs);
  Printf.fprintf oc "\nLOG=%s\n%!" (String.concat " " targets);
  Printf.printf "%s has been generated\n%!" fn;
  close_out oc
;;

#use "parseLog.ml";;
open Printf
let gen_pdf () =
  let gl = ["clique"; "ring"; "er"] in
  List.iter (fun n -> sh ("rm -f "^n^".data")) gl; (* because parse_log appends data *) 
  parse_log ["Uniform When Activated", "alea-coloring-unif"] gl daemons;
  parse_log ["Smallest When Activated","alea-coloring"] gl daemons;
  parse_log ["Always the Biggest", "alea-coloring-alt"] gl daemons;
  List.iter (fun n -> sh ("./gen_pdf.r "^n^".data nonreg")) gl;
  ()
;;

